﻿'H8/3694ボードに接続したCogniMemに対してシリアル＜－＞Ｉ２Ｃ経由でアクセスする
Public Class CM_IO


    '***************************************************************************************
    'Neuron Context 
    Shared Sub read_NCR(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_NCR) 'レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub

    Shared Sub write_NCR(ByVal data As Integer)

        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_NCR) 'レジスタアドレス
        SIO.write_int(data) 'data

    End Sub

    '***************************************************************************************
    'Component
    Shared Sub read_component(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_COMP) 'レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub

    Shared Sub write_component(ByVal data As Integer)

        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_COMP) 'レジスタアドレス
        SIO.write_int(data) 'データ

    End Sub

    'componentとlast componentをチップに書き込む
    Shared Sub write_components(ByVal vector() As Integer, ByVal vector_num As Integer)
        Dim i As Integer

        'Component書き込み
        For i = 0 To vector_num - 2
            SIO.write_command("a")
            SIO.write_char(2)
            SIO.write_char(values.CM_COMP) 'レジスタアドレス
            SIO.write_int(vector(i)) 'data
        Next

        'Last Component
        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_LCOMP) 'レジスタアドレス
        SIO.write_int(vector(i)) 'data

    End Sub

    '***************************************************************************************
    'Component Index
    Shared Sub write_INDEX(ByVal data As Integer)

        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_INDEXCOMP) 'レジスタアドレス
        SIO.write_int(data) 'data

    End Sub

    '***************************************************************************************
    '
    Shared Sub read_DIST_CAT(ByRef distance As Integer, ByRef category As Integer)

        '認識結果を読み取る(DISTレジスタ)
        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_DIST) 'レジスタアドレス
        SIO.read_int(distance) 'データ

        '認識結果を読み取る(CATレジスタ)
        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_CAT) 'レジスタアドレス
        SIO.read_int(category) 'データ
        category = category And &H7FFF

    End Sub

    Shared Sub read_CAT(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_CAT) 'レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub

    'category をチップに書き込む
    Shared Sub write_CAT(ByVal data As Integer)

        'CATレジスタに値をセット
        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_CAT) 'レジスタアドレス
        SIO.write_int(data) 'data

    End Sub

    '***************************************************************************************
    'Active Influence Field
    Shared Sub read_AIF(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_AIF) 'レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub

    Shared Sub write_AIF(ByVal data As Integer)

        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_AIF) 'レジスタアドレス
        SIO.write_int(data) 'data

    End Sub

    '***************************************************************************************
    'Minmum Influence Field
    Shared Sub read_MINIF(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_MINIF) 'レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub

    Shared Sub write_MIN(ByVal data As Integer)

        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_MINIF) 'レジスタアドレス
        SIO.write_int(data) 'data

    End Sub

    '***************************************************************************************
    'Maxmum Influence Field
    Shared Sub read_MAXIF(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_MAXIF) 'レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub

    Shared Sub write_MAXIF(ByVal data As Integer)

        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_MAXIF) 'レジスタアドレス
        SIO.write_int(data) 'data

    End Sub

    '***************************************************************************************
    'Neuron Identifier
    Shared Sub read_NID(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_NID) 'レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub
    '***************************************************************************************
    'Neuron Context 
    Shared Sub read_GCR(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_GCR) 'レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub

    Shared Sub write_GCR(ByVal data As Integer)

        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_GCR) 'レジスタアドレス
        SIO.write_int(data) 'data

    End Sub

    '***************************************************************************************
    'Reset Chain
    Shared Sub write_ResetChain(ByVal data As Integer)

        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_RESETCHAIN) 'レジスタアドレス
        SIO.write_int(data) 'data

    End Sub

    '***************************************************************************************
    '認識状態　読取
    Shared Sub read_reco_status(ByRef uncertain As Integer, ByRef identified As Integer)

        Dim i As Integer

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_NSR) 'NSR レジスタアドレス
        SIO.read_int(i) 'データ

        uncertain = i And 4
        If uncertain <> 0 Then uncertain = 1

        identified = i And 8
        If identified <> 0 Then identified = 1

    End Sub

    'Network Status
    Shared Sub read_NSR(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_NSR) 'NSR レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub

    'Network Status
    Shared Sub write_NSR(ByVal data As Integer)

        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_NSR) 'レジスタアドレス
        SIO.write_int(data) 'data

    End Sub

    '***************************************************************************************
    '学習結果を全てクリア
    Shared Sub write_forget()

        'Reset region of interest
        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_ROIINIT) 'レジスタアドレス
        SIO.write_int("0") 'データ

        'Forget all
        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_FORGET) 'レジスタアドレス
        SIO.write_int("0") 'データ

        'Clear network status register
        SIO.write_command("a")
        SIO.write_char(2)
        SIO.write_char(values.CM_NSR) 'レジスタアドレス
        SIO.write_int("0") 'データ

    End Sub

    '***************************************************************************************
    '使用済みニューロン数を読取
    Shared Sub read_NCOUNT(ByRef data As Integer)

        SIO.write_command("a")
        SIO.write_char(3)
        SIO.write_char(values.CM_NCOUNT) 'レジスタアドレス
        SIO.read_int(data) 'データ

    End Sub
End Class
