﻿Public Class CM_util1

    'ベクトルデータをCogniMemに送り、認識結果を受け取る
    Shared Sub RecognizeVector(ByVal vector() As Integer, ByVal vector_num As Integer, _
                               ByRef log_str As String, ByRef result_set() As String, ByRef result_num As Integer, _
                               ByRef identified As Integer, ByRef uncurtain As Integer)

        Dim distance, category As Integer
        'Dim MINIF, MAXIF As Integer

        'H8/3494ボードに接続したCogniMemへベクトルを送る
        CM_IO.write_components(vector, vector_num)

        '認識結果を読み取る(NSR レジスタ)
        CM_IO.read_reco_status(uncurtain, identified)

        log_str = ""
        log_str = log_str + "------<< Start >>-----" + vbCrLf
        log_str = log_str + "Uncurtain = " + Format(uncurtain) + vbCrLf
        log_str = log_str + "Identified = " + Format(identified) + vbCrLf

        result_num = 0

        If uncurtain = 0 And identified = 0 Then
            '認識できなかった場合
            log_str = log_str + "認識できませんでした。" + vbCrLf
            Exit Sub
        End If

        log_str = log_str + "-----<< Result >>-----" + vbCrLf
        If identified <> 0 Then
            '全てのニューロンの出力が一致しているので１回読めばよい
            '認識結果を読み取る
            'CM_IO.read_MINIF(MINiF)
            'log_str = log_str + "MINIF = " + Format(MINIF) + vbCrLf
            'CM_IO.read_MAXIF(MAXIF)
            'log_str = log_str + "MAXIF = " + Format(MAXIF) + vbCrLf
            '(DIST, CATレジスタ)
            CM_IO.read_DIST_CAT(distance, category)
            log_str = log_str + "Distance = " + Format(distance) + vbCrLf
            log_str = log_str + "Category = " + Format(category) + vbCrLf
            log_str = log_str + "----------------------" + vbCrLf
            result_set(result_num) = Format(distance) + "," + Format(category)
            result_num = result_num + 1
        Else
            'ニューロンの回答にバリエーションがあった場合
            Do
                '認識結果を読み取る
                'CM_IO.read_MINIF(MINIF)
                'log_str = log_str + "MINIF = " + Format(MINIF) + vbCrLf
                'CM_IO.read_MAXIF(MAXIF)
                'log_str = log_str + "MAXIF = " + Format(MAXIF) + vbCrLf
                '(DIST, CATレジスタ)
                CM_IO.read_DIST_CAT(distance, category)
                If distance <> &HFFFF Then
                    log_str = log_str + "Distance = " + Format(distance) + vbCrLf
                    log_str = log_str + "Category = " + Format(category) + vbCrLf
                    log_str = log_str + "----------------------" + vbCrLf
                    result_set(result_num) = Format(distance) + "," + Format(category)
                    result_num = result_num + 1
                End If
            Loop While distance <> &HFFFF
        End If

    End Sub

    'KnowledgeをCogniMem から読み取ってファイルにセーブする
    Shared Sub SaveKnowledge(ByRef filename As String)
        Dim i, data, context, component(256), aif, id, cat As Integer

        FileOpen(1, filename, OpenMode.Output)

        'チップのモードをSR(Save/Restore)モードに変更
        CM_IO.read_NSR(data)
        data = data Or &H10
        CM_IO.write_NSR(data)

        'Write ResetChane
        CM_IO.write_ResetChain(0)

        Print(1, "ROI Height,")
        PrintLine(1, values.ROI_height)
        Print(1, "ROI Width,")
        PrintLine(1, values.ROI_width)
        Do
            'Read Context
            CM_IO.read_NCR(context)

            'read components
            For i = 0 To 255
                CM_IO.read_component(component(i))
            Next

            'read AIF
            CM_IO.read_AIF(aif)

            'read identifier
            CM_IO.read_NID(id)

            'read category
            CM_IO.read_CAT(cat)

            '*******************************
            If cat <> 0 Then
                Print(1, "context,")
                PrintLine(1, context)
                For i = 0 To 255
                    Print(1, "component,")
                    PrintLine(1, component(i))
                Next
                Print(1, "aif,")
                PrintLine(1, aif)
                Print(1, "id,")
                PrintLine(1, id)
                Print(1, "cat,")
                PrintLine(1, cat)
                Print(1, "カテゴリー情報,")
                PrintLine(1, values.cat_comment(cat))

            End If
        Loop While cat <> 0 'CAT=0になったら読み取り完了

        'チップのモードをLR(Learn/Recognize)モードに変更
        CM_IO.read_NSR(data)
        data = data And &HEF
        CM_IO.write_NSR(data)

        FileClose(1)

    End Sub

    'Knowledgeをファイルから読み込みCogniMemに書き込む
    Shared Sub RestoreKnowledge(ByVal filename As String)

        Dim i, data, context, component(256), aif, id, cat As Integer
        Dim work_str_arr() As String

        FileOpen(1, filename, OpenMode.Input)

        '記憶クリア
        CM_IO.write_forget()

        'チップのモードをSR(Save/Restore)モードに変更
        CM_IO.read_NSR(data)
        data = data Or &H10
        CM_IO.write_NSR(data)

        work_str_arr = LineInput(1).Split(",")
        If work_str_arr(0) = "ROI Height" Then values.ROI_height = Val(work_str_arr(1))
        work_str_arr = LineInput(1).Split(",")
        If work_str_arr(0) = "ROI Width" Then values.ROI_width = Val(work_str_arr(1))
        Do While Not EOF(1)

            '*******************************
            work_str_arr = LineInput(1).Split(",")
            If work_str_arr(0) = "context" Then context = Val(work_str_arr(1))
            For i = 0 To 255
                work_str_arr = LineInput(1).Split(",")
                If work_str_arr(0) = "component" Then component(i) = Val(work_str_arr(1))
            Next
            work_str_arr = LineInput(1).Split(",")
            If work_str_arr(0) = "aif" Then aif = Val(work_str_arr(1))
            work_str_arr = LineInput(1).Split(",")
            If work_str_arr(0) = "id" Then id = Val(work_str_arr(1))
            work_str_arr = LineInput(1).Split(",")
            If work_str_arr(0) = "cat" Then cat = Val(work_str_arr(1))
            work_str_arr = LineInput(1).Split(",")
            If work_str_arr(0) = "カテゴリー情報" Then
                values.cat_comment(cat) = work_str_arr(1)
                frmMain.cmbCatList.Items.Add(Str(cat) + "," + work_str_arr(1))
            End If

            'Write Context
            CM_IO.write_NCR(context)

            'Write components
            For i = 0 To 255
                CM_IO.write_component(component(i))
            Next

            'Write AIF
            CM_IO.write_AIF(aif)

            'Write identifier
            'CM_IO.write_INDEX(id)

            'Write category
            CM_IO.write_CAT(cat)
        Loop

        frmMain.cmbCatList.Text = frmMain.cmbCatList.Items(0)

        'チップのモードをLR(Learn/Recognize)モードに変更
        CM_IO.read_NSR(data)
        data = data And &HEF
        CM_IO.write_NSR(data)

        FileClose(1)

    End Sub
End Class
