﻿Imports System.IO
Public Class frmMain

    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim response As MsgBoxResult

        values.inits()

        If Me.SerialPort1.IsOpen = False Then
            Try
                Me.SerialPort1.BaudRate = Me.txtComSpeed.Text
                Me.SerialPort1.PortName = Me.txtComID.Text
                'ポートオープン
                Me.SerialPort1.Open()
            Catch ex As IO.IOException
                response = MsgBox("エラー！シリアルポートＣｈＡのオープンに失敗しました。", MsgBoxStyle.Information)
                Exit Try
            Catch ex As UnauthorizedAccessException
                response = MsgBox("エラー！シリアルポートＣｈＡのオープンに失敗しました。", MsgBoxStyle.Information)
                Exit Try
            End Try
            If Me.SerialPort1.IsOpen = True Then
                'ボタンの色を動作中色に変更
                Me.btnComSwitch.BackColor = values.active_button_color
            End If
        End If

        FileSystemWatcher1.Path = "C:\Msdevstd\work\"
        FileSystemWatcher1.Filter = "notify.txt"
        FileSystemWatcher1.EnableRaisingEvents = False
        FileSystemWatcher1.NotifyFilter = NotifyFilters.LastWrite

        timReqFile.Stop()

    End Sub

    '「接続」ボタンの処理*******************************
    Private Sub btnComSwitch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnComSwitch.Click
        Dim response As MsgBoxResult
        Dim buff(64) As Byte

        'ポートが既に開かれているかチェック
        If Me.SerialPort1.IsOpen = False Then
            Try
                Me.SerialPort1.BaudRate = Me.txtComSpeed.Text
                Me.SerialPort1.PortName = Me.txtComID.Text
                'ポートオープン
                Me.SerialPort1.Open()
            Catch ex As IO.IOException
                response = MsgBox("エラー！シリアルポートＣｈＡのオープンに失敗しました。", MsgBoxStyle.Information)
                Exit Try
            Catch ex As UnauthorizedAccessException
                response = MsgBox("エラー！シリアルポートＣｈＡのオープンに失敗しました。", MsgBoxStyle.Information)
                Exit Try
            End Try
            If Me.SerialPort1.IsOpen = True Then
                'ボタンの色を動作中色に変更
                Me.btnComSwitch.BackColor = values.active_button_color
            End If
        Else
            Try
                'ポートクローズ
                Me.SerialPort1.Close()
            Catch ex As IO.IOException
                response = MsgBox("エラー！シリアルポートＣｈＡのクローズに失敗しました。", MsgBoxStyle.Information)
            End Try
            If Me.SerialPort1.IsOpen = False Then
                'ボタンの色をフォームの背景色に変更
                Me.btnComSwitch.BackColor = values.org_back_color
            End If
        End If
    End Sub


    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        End
    End Sub

    '認識　ボタンの処理
    Private Sub btnRecognize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRecognize.Click

        Dim log_str = "", result_set(1024), work_str(16) As String
        Dim i, result_num, identified, uncurtain As Integer

        btnRecognize.BackColor = values.active_button_color

        CM_util1.RecognizeVector(values.vector, values.vector_num, log_str, result_set, result_num, identified, uncurtain)

        TextBox1.Text = log_str
        If result_num > 0 Then
            work_str = result_set(0).Split(",")
            i = Val(work_str(1))
            TextBox1.AppendText(values.cat_comment(i))
        End If

        btnRecognize.BackColor = values.org_back_color

    End Sub

    '学習　ボタンの処理
    Private Sub btnLearn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLearn.Click

        Dim i As Integer

        'シリアルポートが開いているかチェック
        If Me.SerialPort1.IsOpen = False Then
            MsgBox("先に「接続」して下さい")
            Exit Sub
        End If

        btnLearn.BackColor = values.active_button_color

        'H8/3494ボードに接続したCogniMemへベクトルを送る
        'Component書き込み
        CM_IO.write_components(values.vector, values.vector_num)
        'CATレジスタに値をセット
        CM_IO.write_CAT(txtCatNum.Text)
        '現在の使用ニューロン数
        CM_IO.read_NCOUNT(i)
        txtNeuUsed.Text = i
        'Minimum Influence Field
        CM_IO.read_MINIF(i)
        txtMINIF.Text = i
        'Minimum Influence Field
        CM_IO.read_MAXIF(i)
        txtMAXIF.Text = i

        'カテゴリーの属性セット
        values.cat_comment(Val(txtCatNum.Text)) = txtCatComment.Text

        btnLearn.BackColor = values.org_back_color

    End Sub

    '記憶消去　ボタンの処理
    Private Sub btnForget_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnForget.Click

        Dim buff(64) As Byte

        'シリアルポートが開いているかチェック
        If Me.SerialPort1.IsOpen = False Then
            MsgBox("先に「接続」して下さい")
            Exit Sub
        End If

        btnForget.BackColor = values.active_button_color

        CM_IO.write_forget()

        For i = 0 To 1024
            cat_comment(i) = ""
        Next

        TextBox1.Clear()

        btnForget.BackColor = values.org_back_color

    End Sub

    '更新ＯＮ　ボタンの処理
    Private Sub brnCapture_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles brnCapture.Click
        Dim fs_r As FileStream
        Dim image_r As Image

        If FileSystemWatcher1.EnableRaisingEvents = False Then
            '注意：Image.FromFileで表示すると、ＶＢが起動中ファイルにロックがかかり更新不可となってしまうので
            '　　　Streamを使う。ただし、Streamで表示したイメージはSaveメソッドが使えないので要検討
            fs_r = New FileStream(right_src_fname, FileMode.Open, FileAccess.Read)
            image_r = System.Drawing.Image.FromStream(fs_r)
            fs_r.Close()

            PictureBox1.Image = image_r

            FileSystemWatcher1.EnableRaisingEvents = True
            timReqFile.Start()

            brnCapture.BackColor = Color.YellowGreen
        Else
            FileSystemWatcher1.EnableRaisingEvents = False
            timReqFile.Stop()

            brnCapture.BackColor = org_back_color
        End If

    End Sub


    '更新ＯＮ　ボタンのイベント付随処理（ＶＣのプロセスにキャプチャを要求する）
    Private Sub timReqFile_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles timReqFile.Tick

        'リクエストファイルが無い場合、ファイルを作ってリクエスト
        'ある場合は、処理中か、もしくは相手プロセスが停止中
        'キャプチャ成功時は、相手プロセスにより消去される
        If Not IO.File.Exists(req_fname) Then
            FileOpen(11, req_fname, OpenMode.Output)
            Print(11, "これはCM_trainer1.vb用のキャプチャリクエストファイルです。")
            FileClose(11)
        End If

    End Sub

    '更新ＯＮ　ボタンのイベント発生時の処理
    Private Sub FileSystemWatcher1_Changed(ByVal sender As Object, ByVal e As System.IO.FileSystemEventArgs) Handles FileSystemWatcher1.Changed

        Dim fs_r As FileStream
        Dim image_r As Image

        Dim i As Integer
        Dim log_str = "", result_set(1024), work_str(16) As String
        Dim result_num, identified, uncurtain As Integer
        Dim X, Y, orgROI_X, orgROI_Y, track_step, min_dist, min_X, min_Y As Integer
        Dim category, distance, find_flg, track_cat_num As Integer

        FileSystemWatcher1.EnableRaisingEvents = False

        '注意：Image.FromFileで表示すると、ＶＢが起動中ファイルにロックがかかり更新不可となってしまうので
        '　　　Streamを使う。ただし、Streamで表示したイメージはSaveメソッドが使えないので要検討
        fs_r = New FileStream(right_src_fname, FileMode.Open, FileAccess.Read)
        image_r = System.Drawing.Image.FromStream(fs_r)
        fs_r.Close()

        PictureBox1.Image = image_r

        '追跡ＯＮの処理
        If chkTracking.Checked = True Then

            If radioROI0.Checked = True Then
                i = 16
                values.ROI_magni = 1.0
            ElseIf radioROI1.Checked = True Then
                i = 32
                values.ROI_magni = 2.0
            ElseIf radioROI2.Checked = True Then
                i = 64
                values.ROI_magni = 4.0
            End If
            values.ROI_width = i
            values.ROI_height = i

            orgROI_X = values.ROI_X
            orgROI_Y = values.ROI_Y
            track_step = 4 * values.ROI_magni
            min_dist = &HFFFF
            min_X = 0
            min_Y = 0
            find_flg = 0

            work_str = cmbCatList.Text.Split(",")
            track_cat_num = Val(work_str(0))

            For Y = -1 To 1
                values.ROI_Y = orgROI_Y + Y * track_step
                For X = -1 To 1
                    values.ROI_X = orgROI_X + X * track_step

                    img1.ChangeROI(0)

                    '最新のＲＯＩを認識にかける

                    btnRecognize.BackColor = values.active_button_color

                    CM_util1.RecognizeVector(values.vector, values.vector_num, log_str, result_set, result_num, identified, uncurtain)

                    TextBox1.Text = log_str
                    If result_num > 0 Then
                        work_str = result_set(0).Split(",")
                        distance = Val(work_str(0))
                        category = Val(work_str(1))

                        If category = track_cat_num Then
                            lbCogniResult.Text = values.cat_comment(category)

                            If distance < min_dist Then
                                min_dist = distance
                                min_X = X
                                min_Y = Y
                            End If
                            find_flg = find_flg + 1

                        End If

                    Else
                        lbCogniResult.Text = "不明"
                    End If

                    btnRecognize.BackColor = values.org_back_color
                Next X
            Next Y

            If find_flg > 0 Then
                values.ROI_X = orgROI_X + min_X * track_step
                values.ROI_Y = orgROI_Y + min_Y * track_step
                TextBox1.Text = ""
                TextBox1.AppendText("min_X:" + Format(min_X) + vbCrLf)
                TextBox1.AppendText("min_Y:" + Format(min_Y) + vbCrLf)
                img1.ChangeROI(1)
            Else
                TextBox1.Text = "不明"
            End If

        End If


        FileSystemWatcher1.EnableRaisingEvents = True

    End Sub

    'ＲＯＩ更新　ボタンの処理
    Private Sub btnChageROI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChageROI.Click

        Dim fs_r As FileStream
        Dim image_r As Image

        If btnChageROI.BackColor = org_back_color Then
            '注意：Image.FromFileで表示すると、ＶＢが起動中ファイルにロックがかかり更新不可となってしまうので
            '　　　Streamを使う。ただし、Streamで表示したイメージはSaveメソッドが使えないので要検討
            fs_r = New FileStream(right_src_fname, FileMode.Open, FileAccess.Read)
            image_r = System.Drawing.Image.FromStream(fs_r)
            fs_r.Close()

            PictureBox1.Image = image_r

            Timer1.Enabled = True
            btnChageROI.BackColor = Color.YellowGreen
        Else
            Timer1.Enabled = False
            btnChageROI.BackColor = org_back_color
        End If
        Exit Sub

    End Sub

    'ＲＯＩ更新　ボタンのタイマ処理
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        '変数定義
        Dim i As Integer

        Dim log_str = "", result_set(1024), work_str(16) As String
        Dim result_num, identified, uncurtain As Integer

        Timer1.Stop() '処理が終わるまでタイマ停止

        If radioROI0.Checked = True Then
            i = 16
            values.ROI_magni = 1.0
        ElseIf radioROI1.Checked = True Then
            i = 32
            values.ROI_magni = 2.0
        ElseIf radioROI2.Checked = True Then
            i = 64
            values.ROI_magni = 4.0
        End If
        values.ROI_width = i
        values.ROI_height = i

        img1.ChangeROI(0)

        '最新のＲＯＩを認識にかける
        If chkRecog.Checked = True Then

            btnRecognize.BackColor = values.active_button_color

            CM_util1.RecognizeVector(values.vector, values.vector_num, log_str, result_set, result_num, identified, uncurtain)

            TextBox1.Text = log_str
            If result_num > 0 Then
                work_str = result_set(0).Split(",")
                i = Val(work_str(1))
                'TextBox1.AppendText(values.cat_comment(i))
                lbCogniResult.Text = values.cat_comment(i)
            Else
                lbCogniResult.Text = "不明"
            End If

            btnRecognize.BackColor = values.org_back_color

        End If

        Timer1.Start() 'タイマー再スタート

    End Sub

    'マウスの指示でＲＯＩの座標を取り込むイベント
    Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        Dim X As Integer
        Dim Y As Integer

        X = PictureBox1.PointToClient(System.Windows.Forms.Cursor.Position).X - values.ROI_width / 2
        Y = PictureBox1.PointToClient(System.Windows.Forms.Cursor.Position).Y - values.ROI_height / 2

        If X < 0 Then X = 0
        If Y < 0 Then Y = 0

        If X + values.ROI_width > PictureBox1.Width Then X = PictureBox1.Width - values.ROI_width - 1
        If Y + values.ROI_height > PictureBox1.Height Then Y = PictureBox1.Height - values.ROI_height - 1

        values.ROI_X = X
        values.ROI_Y = Y

        Do
            If (Control.MouseButtons And MouseButtons.Left) = MouseButtons.Left Then Exit Do
            My.Application.DoEvents()
        Loop While 1 = 1


        Label7.Text = X & ", " & Y

    End Sub

    'Saveボタンの処理・・・ニューロンの記憶情報をディスクにセーブする
    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click

        Dim component(256) As Integer
        Dim filename As String

        btnSave.BackColor = values.active_button_color
        '出力ファイル名セット
        filename = ""
        utils.get_unique_fname(filename, values.neuron_fname)
        TextBox1.Text = filename

        CM_util1.SaveKnowledge(filename)

        btnSave.BackColor = values.org_back_color

    End Sub

    'Loadボタンの処理・・・・・・ニューロンの記憶情報をディスクからロードする
    Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click

        Dim component(256) As Integer
        Dim filename As String

        btnLoad.BackColor = values.active_button_color
        '入力ファイルを開く
        OpenFileDialog1.InitialDirectory = "C:\Users\koji\Documents\Visual Studio 2008\Projects\CM_trainer1\CM_trainer1\bin\Debug"
        OpenFileDialog1.Filter = "dat files (*.dat)|*.dat|All files (*.*)|*.*"
        OpenFileDialog1.FilterIndex = 2
        OpenFileDialog1.RestoreDirectory = True
        OpenFileDialog1.ShowDialog()

        filename = OpenFileDialog1.FileName
        TextBox1.Text = filename

        CM_util1.RestoreKnowledge(filename)

        If values.ROI_width = 16 Then
            radioROI0.Checked = True
            radioROI1.Checked = False
            radioROI2.Checked = False
        ElseIf values.ROI_width = 32 Then
            radioROI0.Checked = False
            radioROI1.Checked = True
            radioROI2.Checked = False
        ElseIf values.ROI_width = 64 Then
            radioROI0.Checked = False
            radioROI1.Checked = False
            radioROI2.Checked = True
        End If

        btnLoad.BackColor = values.org_back_color

    End Sub

    '画像読込　ボタンの処理
    Private Sub btnImgFileRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnImgFileRead.Click
        Dim fs_r As FileStream
        Dim image_r As Image

        Dim filename As String

        '入力ファイルを開く
        OpenFileDialog1.InitialDirectory = "C:\Msdevstd\work"
        OpenFileDialog1.Filter = "bmp files (*.bmp)|*.bmp|All files (*.*)|*.*"
        OpenFileDialog1.FilterIndex = 2
        OpenFileDialog1.RestoreDirectory = True
        OpenFileDialog1.ShowDialog()

        filename = OpenFileDialog1.FileName
        TextBox1.Text = filename

        '注意：Image.FromFileで表示すると、ＶＢが起動中ファイルにロックがかかり更新不可となってしまうので
        '　　　Streamを使う。ただし、Streamで表示したイメージはSaveメソッドが使えないので要検討
        fs_r = New FileStream(filename, FileMode.Open, FileAccess.Read)
        image_r = System.Drawing.Image.FromStream(fs_r)
        fs_r.Close()

        PictureBox1.Image = image_r

    End Sub

    'スキャンボタンの処理
    Private Sub btnScan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScan.Click

        Dim log_str = "", result_set(1024), work_str(16) As String
        Dim result_num, identified, uncurtain As Integer

        Dim i, X, step_x, step_y As Integer

        btnScan.BackColor = Color.YellowGreen

        If radioROI0.Checked = True Then
            i = 16
            values.ROI_magni = 1.0
        ElseIf radioROI1.Checked = True Then
            i = 32
            values.ROI_magni = 2.0
        ElseIf radioROI2.Checked = True Then
            i = 64
            values.ROI_magni = 4.0
        End If
        values.ROI_width = i
        values.ROI_height = i

        step_x = 4 * values.ROI_magni
        step_y = 4 * values.ROI_magni

        '高さ方向は、ROIの最終値から始める。水平方向はイメージの左端
        For values.ROI_Y = values.ROI_Y To PictureBox1.Height - values.ROI_height - 1 Step step_y
            values.ROI_X = 0
            'For X = 0 To (PictureBox1.Width - values.ROI_width) / step_x - 1
            For X = 0 To (PictureBox1.Width - values.ROI_width) / step_x - 1
                img1.ChangeROI(0)
                values.ROI_X = values.ROI_X + step_x
                My.Application.DoEvents()

                'ＲＯＩを認識にかける
                If chkRecog.Checked = True Then

                    btnRecognize.BackColor = values.active_button_color

                    CM_util1.RecognizeVector(values.vector, values.vector_num, log_str, result_set, result_num, identified, uncurtain)

                    TextBox1.Text = log_str
                    If result_num > 0 Then
                        work_str = result_set(0).Split(",")
                        i = Val(work_str(1))
                        TextBox1.AppendText(values.cat_comment(i))
                    End If

                    btnRecognize.BackColor = values.org_back_color
                Else
                    '中断処理
                    X = 9999
                    MsgBox("スキャンを中断しました。")
                    Exit For
                End If

            Next
            'values.ROI_Y = values.ROI_Y + step_y
            If X = 9999 Then Exit For
        Next
        btnScan.BackColor = org_back_color

    End Sub

    'チップのモード変更（ＫＮＮ／ＲＢＦ）
    Private Sub btnChangeMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChangeMode.Click

        Dim data As Integer

        If RadioButton1.Checked = True Then
            'チップのモードをRBFモードに変更
            CM_IO.read_NSR(data)
            data = data And &HDF
            CM_IO.write_NSR(data)
        Else
            'チップのモードをKNNモードに変更
            CM_IO.read_NSR(data)
            data = data Or &H20
            CM_IO.write_NSR(data)
        End If

    End Sub

    'チップのモード変更（Ｌ１／Ｌ　Ｓｕｐ）
    Private Sub btnChangeNorm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnChangeNorm.Click

        Dim data As Integer

        If RadioButton4.Checked = True Then
            'チップのモードをL1モードに変更
            CM_IO.read_GCR(data)
            data = data And &HFF7F
            CM_IO.write_GCR(data)
        Else
            'チップのモードをL Supモードに変更
            CM_IO.read_GCR(data)
            data = data Or &H80
            CM_IO.write_GCR(data)
        End If

    End Sub
End Class
